package distantplanets;

import com.sun.java_cup.internal.internal_error;

import driver.Binary;

public class Planetscape {
	/* 
	 * structure is an attempt to mirror the structure of the disassembled code, thus
	 * the excessive functions and names just for names' sake
	 */
	
	Screen screen1;
	
	Random rand;
	
	int [] AnArray;
	int AnArrayCounter;
	int [] palette; // palette
	SomeStruct [] StructArray;
	
	int anotherSeed;
	int HorizonLine;
	int anotherSeed3;
	int anotherSeed4;
	int anotherSeed5;
	int anotherSeed6;
	int anotherSeed7;
	int anotherSeed8;
	int anotherSeed9;
	
	int landscapeType;
	
	int MinY;
	int MinX;
	int MaxY;
	int MaxX;
	
	int ValCleared3;
	
	boolean Flag1;
	boolean SkyFlag;
	int Flag1to4;

	public Planetscape() {
		screen1 = new Screen(800,640);
		MinY=0;
		MinX=0;
		MaxY=0x257;
		MaxX=0x31f;
		
		// 24974
		//DoThatThang(3049);
		//DoThatThang(21938);
		//DoThatThang(3674);
		DoThatThang(1);
	}
	
	public Screen getScreen() {return screen1;}
	
	void DoThatThang(int seed) {
		if (seed<0) seed=(new java.util.Random().nextInt())&0x7fff;
		System.out.println("image number "+seed);
		rand = new Random(seed);
		
		screen1.clear();
		
		RandomCrap1();
		
		// these aren't used yet (until after RandomCrap3), but I need to call rand.rand() twice
		int features=rand.rand()%3;
		int t=rand.rand()&1;
		
		DrawSky();
		
		if (features != 0) {
			Galaxy();
		}
		if (features != 2) {
			Planet1();
			Planet2();
		}
	}
	
	/**
	 * setup palette, decide what kind of scene to draw
	 *
	 */
	void RandomCrap1() {
		palette = new int [0x100];
		for (int i=0;i<palette.length;i++) palette[i]=0; // redundant in Java?
		initAnArray();
		
		// are we seeing fixed point arithmetic here?
		long tmp = 0x31Fl*25l*0x51eb851fl;
		tmp >>= 32;
		anotherSeed = (int)(tmp/32 + ((tmp >> 31) & 1));
		
		System.out.println("anotherSeed="+anotherSeed);
		
		// decide scene type?
		
		long landnum = rand.rand() % 0x64;
		
		if (landnum < 0x14) landscapeType=0; // layered mountains
		else if (landnum < 0x28) landscapeType=1; // hilly
		else if (landnum < 0x3c) landscapeType=2; // flat
		else landscapeType=3; // ocean + mountains on horizon
		
		System.out.println("landscape type: "+landscapeType);
		
		tmp=((AnArray[AnArrayCounter&0x3fff]%0x19)+0x3c)*(long)(0x257-MinY)*0x51eb851fl;
		tmp >>= 32;
		HorizonLine = (int)(tmp / 32 + ((tmp >> 31) & 1)) + MinY;
		
		AnArrayCounter++;
		
		if (landscapeType==3) {
			tmp=((AnArray[AnArrayCounter&0x3fff]%0x1e)+0x32)*(long)(0x257-MinY)*0x51eb851fl;
			tmp >>= 32;
			HorizonLine = (int)(tmp / 32 + ((tmp >> 31) & 1)) + MinY;
			
			AnArrayCounter++;
		}
		
		System.out.println("anotherSeed2="+HorizonLine);
		
		Flag1 = (rand.rand()&1)==1;
		SkyFlag = (rand.rand()&1)==1;
		Flag1to4 = (rand.rand()&3)+1;
		
		System.out.println("Flag1="+Flag1);
		System.out.println("Flag2="+SkyFlag);
		System.out.println("Flag1to4="+Flag1to4);
		
		int temprand = rand.rand();
		temprand = (temprand&(~0xff)) | ((-(temprand&3))&0xff); 
		int borrow=0;
		if ((temprand&0xff)!=0) borrow=1;
		
		ValCleared3=0;
		
		anotherSeed3=-(temprand-(temprand+borrow));
		System.out.println("anotherSeed3="+anotherSeed3);
		
		
		if (SkyFlag && anotherSeed3 != 0) {
			ValCleared3=(rand.rand()&7)+0x14;
		} else {
			long r = rand.rand();
			r = r%0x18+4;
			
			ValCleared3=(int)r;
		}
		
		System.out.println("ValCleared3=0x"+Binary.intToHex(ValCleared3));
		
		{
			int i;
			if ((rand.rand()&1) == 1 && ValCleared3 > 0x10) {
				i=1;
			} else {
				i=0;
			}
			
			anotherSeed4=i+1;
		}
		
		System.out.println("anotherSeed4="+anotherSeed4);

		anotherSeed5=0x31f;
		anotherSeed6=(rand.rand()%(0x800/((anotherSeed3+1)*6)))-0x800/((anotherSeed3+1)*12);
		
		System.out.println("anotherSeed6="+anotherSeed6+" "+Binary.intToHex(anotherSeed6));
		
		anotherSeed7=(int)(((HorizonLine+MinY)-(((long)HorizonLine+MinY)>>32))>>1);
		System.out.println("anotherSeed7=0x"+Binary.intToHex(anotherSeed7));

		// unsigned multiply
		anotherSeed8=(int)(anotherSeed5-(((rand.rand()%(0x31f-MinX))*0x0CCCCCCCDl)>>35));
		
		System.out.println("anotherSeed8="+Binary.intToHex(anotherSeed8));
		
		{
			int ecx = (MinY+HorizonLine)*anotherSeed6;
			int edx = ((int)((ecx*(long)0xA03C1689)>>32)+ecx)>>8; // signed multiply
			edx+=(edx>>31)&1;
			anotherSeed9=anotherSeed7+edx*2;
			
			System.out.println("anotherSeed9="+Binary.intToHex(anotherSeed9));
		
			if (anotherSeed3 != 0) {
				anotherSeed7 = anotherSeed9 - edx;
				anotherSeed5 = anotherSeed8;
				System.out.println("anotherSeed7="+Binary.intToHex(anotherSeed7));
				System.out.println("anotherSeed5="+Binary.intToHex(anotherSeed5));
			}
		}
		
		{
			int j=0;
			StructArray = new SomeStruct [7];
			for (int i=0;i<=6;i++) {
				if (i >= 5) {
					StructArray[i]=new SomeStruct(j,j+0x1f,HorizonLine,0x257);
				} else {
					StructArray[i]=new SomeStruct(j,j+0x1f,MinY,HorizonLine);
				}
				j+=0x20;
			}			
		}
		
		StructArray[5].x=StructArray[5].w-1;
		StructArray[6].x=StructArray[6].w-1;
		
		if (SkyFlag) {
			generateColors(0,0x0f,0x1c,0x3f,0x20,0x3f);
		} else {
			generateColors(0,0x05,0x1e,0x3a,0x20,0x3f);
		}
		
		generateColors(0x23,0x39,0x3a,0x3f,0x10,0x1f);
		
		generateColors(3,0x1a,0x1c,0x3f,0x80,0x9f);
		
		if (!Flag1) {
			generateColors(1,0x12,0x1a,0x3f,0x40,0x5f);
		} else {
			StructArray[2].x=StructArray[2].w-1;
		}
		
		{
			int color1=0;
			for (int i=0;i<3;i++) {
				color1<<=8;
				int j=AnArray[AnArrayCounter&0x3fff]&0x80000003;
				if (i<0) {
					j--;
					j|=0xFFFFFFFC;
					j++;
				}
				color1|=j+4;
				
				AnArrayCounter++;
			}
			
			int color2=0;
			for (int i=0;i<3;i++) {
				color2<<=8;
				color2|=AnArray[AnArrayCounter&0x3fff]%0x18+0x28;
				AnArrayCounter++;
			}
			
			generateGradient(0x60,0x7f,color1,color2);
		}
	}
	
	void initAnArray() {
		AnArray = new int [0x4000];
		for (int i=0;i<AnArray.length;i++) AnArray[i]=rand.rand();
		AnArrayCounter=0;
	}
	
	void generateColors(int intensity1_start, int intensity1_end, int intensity2_start, int intensity2_end, int startidx, int endidx) {
		int rand1,rand2;
		int [] startcolor1 = new int [3];
		int [] endcolor1 = new int [3];
		int [] startcolor2 = new int [3];
		int [] endcolor2 = new int [3];
		
		System.out.println("RandomCrap2(0x"+Binary.intToHex(intensity1_start)+",0x"+Binary.intToHex(intensity1_end)+
				",0x"+Binary.intToHex(intensity2_start)+",0x"+Binary.intToHex(intensity2_end)+",0x"+Binary.intToHex(startidx)+",0x"+
				Binary.intToHex(endidx)+")");
		
		rand1=rand.rand()%3; // choose channel to change in start colors 
		rand2=rand.rand()%3; // choose channel to change in end colors
		
		// loop through channels
		for (int i=0;i<3;i++) {
			startcolor1[i]=intensity1_start;
			endcolor1[i]=intensity1_end;
			startcolor2[i]=intensity2_start;
			endcolor2[i]=intensity2_end;
			if (i==rand1) {
				startcolor1[i]=(intensity1_start+intensity1_end)/2;
				startcolor2[i]=(intensity2_start+intensity2_end)/2;
			} else if (i==rand2) {
				endcolor1[i]=(intensity1_start+intensity1_end)/2;
				endcolor2[i]=(intensity2_start+intensity2_end)/2;
			}
		}
		
		{
			int [] color5 = new int [3];
			int [] color6 = new int [3];
			
			color5[0] = (int)((long)AnArray[AnArrayCounter&0x3fff]%(endcolor1[0]-startcolor1[0]+1)+startcolor1[0]);				
			AnArrayCounter++;
			color5[1] = (int)((long)AnArray[AnArrayCounter&0x3fff]%(endcolor1[1]-startcolor1[1]+1)+startcolor1[1]);
			AnArrayCounter++;
			color5[2] = (int)((long)AnArray[AnArrayCounter&0x3fff]%(endcolor1[2]-startcolor1[2]+1)+startcolor1[2]);			
			AnArrayCounter++;
			
			color6[0] = (int)((long)AnArray[AnArrayCounter&0x3fff]%(endcolor2[0]-startcolor2[0]+1)+startcolor2[0]);			
			AnArrayCounter++;
			color6[1] = (int)((long)AnArray[AnArrayCounter&0x3fff]%(endcolor2[1]-startcolor2[1]+1)+startcolor2[1]);
			AnArrayCounter++;
			color6[2] = (int)((long)AnArray[AnArrayCounter&0x3fff]%(endcolor2[2]-startcolor2[2]+1)+startcolor2[2]);
			AnArrayCounter++;
			
			generateGradient(startidx,endidx,(color5[0]<<16)|(color5[1]<<8)|(color5[2]), (color6[0]<<16)|(color6[1]<<8)|(color6[2]));
		}
	}
	
	void generateGradient(int startidx, int endidx, int startcolor, int endcolor) {
		System.out.println("SomethingElse(0x"+Binary.intToHex(startidx)+",0x"+Binary.intToHex(endidx)+",0x"+
				Binary.intToHex(startcolor)+",0x"+Binary.intToHex(endcolor)+")");
		
		int len=endidx-startidx;
		int col0start=startcolor&0xff;
		int col1start=(startcolor>>8)&0xff;
		int col2start=(startcolor>>16)&0xff;
		int col0end=endcolor&0xff;
		int col1end=(endcolor>>8)&0xff;
		int col2end=(endcolor>>16)&0xff;
		int col0span=col0end-col0start;
		int col1span=col1end-col1start;
		int col2span=col2end-col2start;
		
		int incval0=len*4;
		int incval1=incval0;
		int incval2=incval1;
		
		if (len < 0) {System.out.println("len < 0");}
		if (col0span < 0 || col1span < 0 || col2span < 0) {System.out.println("colspan < 0");}
		if (len==0) return;
				
		for (int i=0;i<=len;i++) {
			palette[i+startidx]=
			(((incval2/(len*2)+col2start*4)&0xff)<<16)|
			(((incval1/(len*2)+col1start*4)&0xff)<<8)|
			(((incval0/(len*2)+col0start*4)&0xff)<<0);
			incval0+=col0span*8;
			incval1+=col1span*8;
			incval2+=col2span*8;
			//System.out.println(i+": "+Binary.intToHex(palette[i+startidx]));
		}
	}
	
	void DrawSky() {
		int var_4,var_8,var_C,var_10;
		if (SkyFlag) {
			int edi=Flag1to4;
			var_C=edi << 8;
			int esi=rand.rand();
			int eax=anotherSeed3<<5;
			eax+=(((long)eax)>>32)&3;
			esi&=3;
			eax>>=2;
			esi+=eax;			
			int ebx=0x31f;
			int ecx=ebx-MinX;
			int ebp=HorizonLine;
			eax=esi;
			eax<<=8;
			ecx++;
			eax=(int)(((long)eax)/ecx);
			ecx=0x3e-esi;
			esi=MinY;
			ecx-=edi;
			edi=ebp-esi;
			var_8=eax;
			eax=(0x20-ecx)<<8;
			eax=(int)(((long)eax)/edi);
			ecx<<=8;
			var_4=eax;
			var_10=ecx;
			
			while (ebp>=MinY) {
				edi=ecx;
				ecx=screen1.getWidth()*ebp;
				esi=MinX;
				while (esi <= ebx) {
					eax=AnArray[AnArrayCounter&0x3fff];
					AnArrayCounter++;
					int colidx=(eax%var_C+edi)>>8;
					//System.out.println(colidx+" "+edi);
					screen1.setPixel(ecx,palette[colidx]);
					edi+=var_8;
					esi++;
					ecx++;
				}
				ecx=var_10=var_10+var_4;
				ebp--;
			}
			if ((rand.rand()&1)!=1) return;
		}
		
		DrawStars();
	}
	
	/**
	 * stars?
	 *
	 */
	void DrawStars() {
		
		for (int numstars=rand.rand()%0x32+0x4b;numstars>0;numstars--) {
			
			int x = rand.rand()%(MaxX-MinX)+MinX;
			int y = rand.rand()%(HorizonLine-MinY)+MinY;
			
			// if the sky is there we must interpolate
			int newval;
			if (SkyFlag) {
				int curval = screen1.getPixel(x,y);
				//System.out.println("("+x+","+y+")="+Binary.intToHex(screen1.getPixel(x,y)));
				newval= 
					((((rand.rand()&0xff)+(curval&0xff))/2)&0xff) |
					(((((rand.rand()&0xff)<<8)+(curval&0xff00))/2)&0xff00) |
					(((((rand.rand()&0xff)<<16)+(curval&0xff0000))/2)&0xff0000);
				
			} else {
				newval = ((rand.rand()&0xfff)<<12) | (rand.rand()&0xfff);
			}
			screen1.setPixel(x,y,newval);
			//System.out.println("star("+x+","+y+")="+Binary.intToHex(screen1.getPixel(x,y)));
		}
	}
	
	void Galaxy() {
		
	}
	
	void Planet1() {
		System.out.println(Binary.intToHex(rand.rand()));
	}
	
	void Planet2() {
		
	}
}
